threederotation = {}


function threederotation.rotateObjectXAxis(Obj, angle)

    for j, pt in pairs(Obj.points) do
       local x2,y2,z2 = threederotation.rotatePointXAxis(pt, angle)
       pt.x = x2
       pt.y = y2
       pt.z = z2
    end
end

function threederotation.rotatePointXAxis(point, angle)
    -- point has x,y,z
    -- angle is in degs and then converted to rads
    -- returns 3 new points

    local anglerad = math.rad(angle)

    local x1 = point.x
    local y1 = point.y
    local z1 = point.z

    local x2 = x1
    local y2 = x1 * 0 + y1 * math.cos(anglerad) + (z1 * -1 * math.sin(anglerad))
    local z2 = 0 + y1 * math.sin(anglerad) + z1 * math.cos(anglerad)

    return x2, y2, z2
end

function threederotation.rotateObjectYAxis(Obj, angle)
    -- print(inspect(Obj))
    -- print("##################")

    for j, pt in pairs(Obj.points) do
       local x2,y2,z2 = threederotation.rotatePointYAxis(pt, angle)
       pt.x = x2
       pt.y = y2
       pt.z = z2
    end
end

function threederotation.rotatePointYAxis(point, angle)
    local anglerad = math.rad(angle)
    local x1 = point.x
    local y1 = point.y
    local z1 = point.z

    -- print(inspect(point))

    local x2 = x1 * math.cos(anglerad) + 0 + z1 * math.sin(anglerad)
    local y2 = x1 * 0 + y1 * 1 + y1 * 0
    local z2 = x1 * (-1 * math.sin(anglerad)) + y1 * 0 + z1 * math.cos(anglerad)

    return x2, y2, z2
end

function threederotation.rotateObjectZAxis(Obj, angle)
    -- print(inspect(Obj))
    -- print("##################")

    for j, pt in pairs(Obj.points) do
       local x2,y2,z2 = threederotation.rotatePointZAxis(pt, angle)
       pt.x = x2
       pt.y = y2
       pt.z = z2
    end
end

function threederotation.rotatePointZAxis(point, angle)
    local anglerad = math.rad(angle)
    local x1 = point.x
    local y1 = point.y
    local z1 = point.z

    -- print(inspect(point))

    local x2 =  x1 * math.cos(anglerad) + y1 * (-1 * math.sin(anglerad)) + z1 * 0
    local y2 = x1 * math.sin(anglerad) + y1 * math.cos(anglerad) + z1 * 0
    local z2 = x1 * 0 + y1 * 0 + z1 * 1

    return x2, y2, z2
end

return threederotation
